unit example2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  Texample2 = class(TCustomPanel)
  private
   fNewWindowProc : Pointer;  {pointer to our window function}
   fOldWindowProc : Pointer;   {previous window function }
   fTargetHandle : hWnd;
   fSubClassDone : boolean;
   Procedure NewFormFunction(var msg : tmessage);
   procedure WMPAINT(var Message: TMessage); message WM_PAINT;
  protected
    { Protected declarations }
  public
    constructor create(aOwner: tcomponent); override;
    procedure turnOnSubClassing;
    procedure TurnOffSubClassing;
  published
    property Align;
    property Alignment;
    property BevelInner;
    property BevelOuter;
    property BevelWidth;
    property BorderWidth;
    property BorderStyle;
    property DragCursor;
    property DragMode;
    property Enabled;
    property FullRepaint;
    property Caption;
    property Color;
    property Ctl3D;
    property Font;
    property Locked;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnResize;
    property OnStartDrag;
  end;

procedure Register;

implementation

constructor Texample2.create(aOwner: tcomponent);
begin
  inherited create(aowner);
  fsubclassDone := false;
  bevelInner := bvLowered;
  bevelWidth := 3;
  caption := 'Subclassing off';
  end;

procedure Texample2.NewFormFunction(var msg : tmessage);
begin
  case msg.msg of
     WM_LBUTTONDOWN : color := clFuchsia;
     WM_RBUTTONDOWN : color := clTeal;
     end;
  msg.Result := CallWindowProc(fOldWindowProc, fTargetHandle, msg.Msg, msg.wParam, msg.LParam);
end;

procedure Texample2.WMPAINT(var Message: TMessage);
begin
  inherited;
  if not fSubclassDone
    then TurnOnSubclassing;
end;

procedure Texample2.turnOnSubClassing;
begin
   fTargetHandle := parent.handle;
   fNewWindowProc := MakeObjectInstance(NewFormFunction);
   fOldWindowProc := Pointer(SetWindowLong(fTargetHandle, GWL_WNDPROC, LongInt(fNewWindowProc)));
   caption := 'eg2: Subclassing on';
   fsubclassDone := true;
end;

procedure Texample2.TurnOffSubClassing;
begin
   SetWindowLong(fTargetHandle, GWL_WNDPROC, longint(fOldWindowProc));
   FreeObjectInstance(fNewWindowProc);
   caption := 'eg2: Subclassing off';
   color := clBtnFace;
   fSubclassDone := false;
end;


procedure Register;
begin
  RegisterComponents('Samples', [Texample2]);
end;

end.
